define bi_java::jdk (
    $package_name = $title,
    $java_conf = undef,
    $java_home = undef,
    $java_opts = undef,
) {
    require bi_banner
    require bi_java::etc
    
    if $package_name == undef or !is_string($package_name) { 
        fail("'package_name' must be defined") 
    }
    
    if $java_home == undef or !is_string($java_home) { 
        fail("'java_home' must be defined") 
    }
    
    if $java_conf == undef or !is_string($java_conf) { 
        fail("'java_conf' must be defined") 
    }
    
    #if $java_opts == undef or !is_string($java_opts) { fail("'java_opts' must be defined") }
    
    package { $package_name:
        ensure => 'installed',
        #allow_virtual => false,
    }
    
    # Explicitly set allow_virtual to disable deprecation warning
    # http://docs.puppetlabs.com/puppet/3.6/reference/release_notes.html#changes-to-rpm-behavior-with-virtual-packages
    
    file { $java_conf:
        ensure => "present",
        content => template("$bi_banner::pound_header", 'bi_java/etc/java/java.conf.erb'),
        mode => '644',
        owner => 'root',
        group => 'root',
    }

}